/*
 * FilterData.java
 *
 * Created on September 22, 2004, 5:15 AM
 */

/**
 *
 * @author  gautham_anil
 */
public class FilterData extends javax.swing.table.AbstractTableModel {
    
    QueryFilter[] filters;
    //DBInterface db;
    static String[] subjects;
    
    /** Creates a new instance of FilterData */
    public FilterData() {
        subjects = new DBInterface().getSubjectArray();
        filters = new QueryFilter[subjects.length];
        for(int i=0; i<filters.length; i++) {
            filters[i] = new QueryFilter(subjects[i]);
        }
    }
    
    public int getColumnCount() {
        return 4;
    }
    
    public int getRowCount() {
        return subjects.length;
    }
    
    public Object getValueAt(int rowIndex, int columnIndex) {
        switch(columnIndex) {
            case 0: return  new Boolean(filters[rowIndex].active);
            case 1: return filters[rowIndex].subject;
            case 2: return new Integer(filters[rowIndex].lower);
            case 3: return new Integer(filters[rowIndex].upper);
            default: {
                System.out.println("Incorrect column asked for.");
                return null;
            }
        }
    }
    
    public void setValueAt(Object value, int rowIndex, int columnIndex) {
        switch(columnIndex) {
            case 0: filters[rowIndex].active = ((Boolean)value).booleanValue(); break;
            case 2: filters[rowIndex].lower = ((Integer)value).intValue(); break;
            case 3: filters[rowIndex].upper = ((Integer)value).intValue(); break;
            default: {
                System.out.println("Incorrect column asked for.");
                return;
            }
        }
    }
    
    public String getColumnName(int columnIndex) {
        /*boolean test = (columnIndex <= 2);
        assert test;*/
        switch(columnIndex) {
            case 0: return "Active";
            case 1: return "Subject";
            case 2: return "Lower limit";
            case 3: return "Upper limit";
        }
        return "";
    }
    
    public boolean isCellEditable(int row, int columnIndex) {
        /*boolean test = (columnIndex <= 2);
        assert test;*/
        switch(columnIndex) {
            case 0: return true;
            case 1: return false;
            case 2: return true;
            case 3: return true;
        }
        return false;
    }
    
    public void incFilter() {
        //filters.add(new QueryFilter());
        //fireTableRowsInserted(filters.size() -1, filters.size() -1);
    }
    
    public void decFilter() {
        //filters.remove(filters.size() - 1);
        //fireTableRowsDeleted(filters.size(), filters.size());
        
    }
    
    public String getQuery() {
        StringBuffer sS = new StringBuffer("c1.loginid as Login "); /* selectString */
        StringBuffer fS = new StringBuffer(" "); /* fromString */
        StringBuffer wS = new StringBuffer(""); /* whereString */
        
        boolean anyFilter = false;
        
        int j = 1;
        //if(i.hasNext()) cS.append(i.next().toString());
        for(int i = 0; i< filters.length; i++) {
            QueryFilter qF = filters[i];
            if(qF.active)
                anyFilter = true;
            else continue;
            sS.append(", c" + j + ".marks as " + subjects[j-1]);
            fS.append((j == 1 ? "" : ",") + " marks as c" + j);
            wS.append( (j == 1 ? " " : "\n\t AND ")
            + "(c" + j + ".subjectid = " + getSubjectId(qF.subject)
            + " AND c" + j + ".marks <= " + qF.upper
            + " AND c" + j + ".marks >= " + qF.lower
            + " AND c" + j + ".loginid = c1.loginid"
            + ") "
            );
            j++;
        }
        if(!anyFilter) return "SELECT DISTINCT loginid FROM marks";
        return "SELECT DISTINCT\n\t" + sS + "\n\tFROM\n\t" + fS + "\n\tWHERE\n\t" + wS + " ORDER BY Login";
    }
    
    public static String getLoginQuery(String login) {
        StringBuffer sS = new StringBuffer("c1.loginid as Login "); /* selectString */
        StringBuffer fS = new StringBuffer(" "); /* fromString */
        StringBuffer wS = new StringBuffer(/*" c1.loginid = " + login + " AND "*/""); /* whereString */
        
        //boolean anyFilter = false;
        
        
        
        //int j = 1;
        //if(i.hasNext()) cS.append(i.next().toString());
        for(int i = 1; i<= subjects.length; i++) {
            //QueryFilter qF = filters[i];
            //if(qF.active)
            //    anyFilter = true;
            //else continue;
            sS.append(", c" + i + ".marks as " + subjects[i-1]);
            fS.append((i == 1 ? "" : ",") + " marks as c" + i);
            wS.append( (i == 1 ? " " : "\n\t AND ")
            + "(c" + i + ".subjectid = " + getSubjectId(subjects[i-1])
            + " AND c" + i + ".loginid = '" + login + "' "
            //+ " AND c" + j + ".marks >= " + qF.lower
            + ") "
            );
            
        }
        return "SELECT DISTINCT\n\t" + sS + "\n\tFROM\n\t" + fS + "\n\tWHERE\n\t" + wS + " ORDER BY Login";
    }
    
    static private int getSubjectId(String subject) {
        int i = 0;
        while(!subjects[i].equals(subject)) { i++; }
        return i;
    }
}

class QueryFilter {
    public String subject;
    public int lower, upper;
    public boolean active;
    
    QueryFilter(String s) {
        subject = s;
    }
    
    public String toString() {
        if(!subject.equals(""))
            return " (" + subject + " >= " + lower + " AND " + subject + " <= " + upper + ") ";
        else return "";
    }
    
    public static void main(String args[]) {
        //System.out.println(new QueryFilter());
    }
}