import javax.swing.JOptionPane;

/** This class shows the login prompt.
 *
 * @author  gautham_anil
 */
public class LoginDialogBox extends javax.swing.JDialog implements java.awt.event.ActionListener{
    
    String login;
    
    /** Creates new form LoginDialogBox */
    public LoginDialogBox(/*java.awt.Frame parent, boolean modal*/) {
        super((javax.swing.JFrame)null,"Login",true);
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        loginFormTitle = new javax.swing.JLabel();
        loginPanel = new javax.swing.JPanel();
        usernameLabel = new javax.swing.JLabel();
        usernameText = new javax.swing.JTextField();
        passwordLabel = new javax.swing.JLabel();
        passwordText = new javax.swing.JPasswordField();
        signIn = new javax.swing.JButton();
        exit = new javax.swing.JButton();
        signUp = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.FlowLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Login Page");
        loginFormTitle.setText("<html><div style=\"/*border-style: solid; border-width: 1px; padding: 2px;*/ font-size: 13px; font-style: italic;\">Login Form</div></html>");
        getContentPane().add(loginFormTitle);

        loginPanel.setLayout(new java.awt.GridLayout(2, 2));

        loginPanel.setPreferredSize(new java.awt.Dimension(238, 38));
        usernameLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        usernameLabel.setText("Username : ");
        loginPanel.add(usernameLabel);

        usernameText.setToolTipText("Enter username");
        usernameText.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                keyTyped(evt);
            }
        });

        loginPanel.add(usernameText);

        passwordLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        passwordLabel.setText("Password : ");
        loginPanel.add(passwordLabel);

        passwordText.setToolTipText("Enter your password");
        passwordText.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                keyTyped(evt);
            }
        });

        loginPanel.add(passwordText);

        getContentPane().add(loginPanel);

        signIn.setMnemonic('s');
        signIn.setLabel("Sign In");
        signIn.addActionListener(this);
        getContentPane().add(signIn);

        exit.setMnemonic('x');
        exit.setText("Exit");
        exit.setToolTipText("Exit the program");
        exit.addActionListener(this);
        getContentPane().add(exit);

        signUp.setMnemonic('u');
        signUp.setText("Unregistered. Sign me up");
        signUp.setActionCommand("Sign Up");
        signUp.addActionListener(this);
        getContentPane().add(signUp);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-274)/2, (screenSize.height-170)/2, 274, 170);
    }//GEN-END:initComponents
    
    private void keyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_keyTyped
        int kC = evt.getKeyCode();
        System.out.println("KeyTyped = " + kC);
        System.out.println("Enter = " + java.awt.event.KeyEvent.VK_ENTER);
        System.out.println("Escape = " + java.awt.event.KeyEvent.VK_ESCAPE);
        if(kC == java.awt.event.KeyEvent.VK_ENTER) {
            doSignIn();
        }
        if(kC == java.awt.event.KeyEvent.VK_ESCAPE) {
            doExit();
        }
    }//GEN-LAST:event_keyTyped
    
    public String showAndGetLogin() {
        usernameText.setText("04305013");
        passwordText.setText("04305013");
        //unregisteredBox.setSelected(false);
        usernameText.requestFocus();
        setVisible(true);
        return login;
    }
    
    private void doSignIn() {
        // do proper verification and sugning up here.
        login = usernameText.getText();
        DBInterface db = new DBInterface();
        String password = db.getUserPassword(login);
        if(password == null) {
            JOptionPane.showMessageDialog(this,"User '" + login + "' could not be authenticated. Please try again.");
            return;
        }
	setVisible(false);
    }
    
    private void doExit() {
        // do proper verification and sugning up here.
        login = null;
        setVisible(false);
        
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        LoginDialogBox ldb = new LoginDialogBox(/*new javax.swing.JFrame(), true*/);
        //ldb.setSize(270, 170);
        ldb.show();
    }
    
    public void actionPerformed(java.awt.event.ActionEvent e) {
        String command = e.getActionCommand();
        if(command.equals("Sign In")) {
            doSignIn();
        }
        if(command.equals("Exit")) doExit();
        if(command.equals("Sign Up")) {
            login = new SignupDialog(this).signup();
            if(login == null) return;
            DBInterface db = new DBInterface();
            if(db.hasBeenSurveyed(login)) {
                System.out.println("User has been surveyed.");
                setVisible(false);
            }
            else {
                System.out.println("User has not been surveyed.");
                String[] subjects = db.getSubjectArray();
                int[] marks = new SurveyPanel(subjects).doSurvey(this);
                for(int i=0; i<marks.length; i++) {
                    db.putMarks(login, subjects[i], new Integer(marks[i]).toString());
                }
            }
            setVisible(false);
        }
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton exit;
    private javax.swing.JLabel loginFormTitle;
    private javax.swing.JPanel loginPanel;
    private javax.swing.JLabel passwordLabel;
    private javax.swing.JPasswordField passwordText;
    private javax.swing.JButton signIn;
    private javax.swing.JButton signUp;
    private javax.swing.JLabel usernameLabel;
    private javax.swing.JTextField usernameText;
    // End of variables declaration//GEN-END:variables
    
}


class SignupDialog extends javax.swing.JDialog implements java.awt.event.FocusListener, java.awt.event.ActionListener {
    
    DBInterface db;
    String login;
    //javax.swing.JDialog d;
    
    public SignupDialog(javax.swing.JDialog d) {
        super(d,"Signup Form",true);
        initComponents();
        db = new DBInterface();
        login = null;
    }
    
    private javax.swing.JPanel mP;
    private javax.swing.JTextField uN;
    private javax.swing.JTextField uLI;
    private javax.swing.JTextField uP;
    private javax.swing.JTextField uPC;
    private javax.swing.JButton s;
    
    private void initComponents() {
        mP = new javax.swing.JPanel();
        uN = new javax.swing.JTextField("");
        uLI = new javax.swing.JTextField("");
        uP = new javax.swing.JPasswordField("");
        uPC = new javax.swing.JPasswordField("");
        s = new javax.swing.JButton("Sign Up");
        
        uN.setColumns(10);
        uLI.setColumns(10);
        uLI.addFocusListener(this);
        uP.setColumns(12);
        uPC.setColumns(12);
        s.addActionListener(this);
        s.setMnemonic('s');
        
        mP.setLayout(new java.awt.GridLayout(4,2));
        mP.add(new javax.swing.JLabel("Name :")); mP.add(uN);
        mP.add(new javax.swing.JLabel("LoginId :")); mP.add(uLI);
        mP.add(new javax.swing.JLabel("Password :")); mP.add(uP);
        mP.add(new javax.swing.JLabel("Retype Password :")); mP.add(uPC);
        
        this.getContentPane().setLayout(new java.awt.BorderLayout());
        this.getContentPane().add(mP, java.awt.BorderLayout.CENTER);
        this.getContentPane().add(s, java.awt.BorderLayout.SOUTH);
        
        //this.setSize(300, 130);
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-300)/2, (screenSize.height-130)/2, 300, 130);
    }
    
    public void focusGained(java.awt.event.FocusEvent e) {
    }
    
    public void focusLost(java.awt.event.FocusEvent e) {
        String l =  uLI.getText();
        if(db.getUserPassword(l) != null) {
            JOptionPane.showMessageDialog(this,"The login '" + l + "' is already in use. Please choose another one.");
            uLI.requestFocus();
        }
        
    }
    
    public void actionPerformed(java.awt.event.ActionEvent e) {
        if(uLI.getText().equals("") || uP.getText().equals("")) {
            JOptionPane.showMessageDialog(this,"You cannot leave the login or password field empty. Please fill them up.");
            uP.requestFocus();
            return;
        }
        if(db.getUserPassword(uLI.getText()) != null) {
            JOptionPane.showMessageDialog(this,"The login '" + uLI.getText() + "' is already in use. Please choose another one.");
            uLI.requestFocus();
            return;
        }
        if(!uP.getText().equals(uPC.getText())) {
            JOptionPane.showMessageDialog(this,"The passwords dont match. Please enter them again.");
            uP.requestFocus();
            return;
        }
        login = uLI.getText();
        db.putUser(login, uP.getText(), uN.getText());
        this.dispose();
    }
    
    public String signup() {
        setVisible(true);
        return login;
    }
}
