import javax.swing.*;
import java.awt.geom.*;
import java.awt.*;
import java.io.*;
import java.util.*;

public class PieChart extends JPanel{
    static int[] data = {0,0,0,0,0,0,0,0,0,0,0};
    static int noOfBars=1;
    int[] graphData;
    static String field="hockey";
    int clusterNo[];
    int clusterSize[];
    int total;
    static boolean empty=true;
    String title;
    static int radious=0;
    double angles[];
    static Color[] clr;
    static int nClrs=0;
    static Color bgClr;
    double maxPie;
    int maxPos;
    int fSz;
    double rAngle; 	
    static int bigPos=0;
    String propFileName="graphicalForm.cfg";

    PieChart(int[] d,int nB,String f) {
        data = d;
        noOfBars = nB;
        field = f;
	readFromFile();
    }
    
    PieChart(){
	clr= new Color[10];
	clr[0]=Color.red;
	clr[1]=Color.green;
	clr[2]=Color.blue;
	clr[3]=Color.yellow;
	bgClr=Color.black;
	readFromFile();
    }
    
    public static void main(String[] args) {
        JFrame j = new JFrame("Test01");
        j.setSize(500, 500);
        j.getContentPane().add(new PieChart(),BorderLayout.CENTER);
        j.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        //j.pack();
        j.setVisible(true);
    }

    void readFromFile(){
try{	FileInputStream fis = new FileInputStream(propFileName);
        Properties dbProps = new Properties();
        dbProps.load(fis);
	String rad=dbProps.getProperty("piechart.radius");
	radious=Integer.parseInt(rad);
	String clrst=dbProps.getProperty("piechart.colorOrder");
	String[] clrAr=clrst.split("\\s");
	clr=new Color[clrAr.length];
	nClrs=clrAr.length;
	System.out.println("************************************************iln");
	for(int i=0;i<clrAr.length;i++)
	    if("black".equals(clrAr[i]))clr[i]=Color.black;
	    else if("white".equals(clrAr[i]))clr[i]=Color.white;
	    else if("blue".equals(clrAr[i]))clr[i]=Color.blue;
	    else if("green".equals(clrAr[i]))clr[i]=Color.green;
	    else if("yellow".equals(clrAr[i]))clr[i]=Color.yellow;
	    else if("magenta".equals(clrAr[i]))clr[i]=Color.magenta;
	    else if("pink".equals(clrAr[i]))clr[i]=Color.pink;
	    else if("cyan".equals(clrAr[i]))clr[i]=Color.cyan;
	    else if("lightgray".equals(clrAr[i]))clr[i]=Color.lightGray;
	    else if("darkgray".equals(clrAr[i]))clr[i]=Color.darkGray;
	    else if("red".equals(clrAr[i]))clr[i]=Color.red;
	    else if("orange".equals(clrAr[i]))clr[i]=Color.orange;
	    else clr[i]=Color.white;
	String col=dbProps.getProperty("piechart.bkgndColor");
	title=dbProps.getProperty("piechart.title");
	//System.out.println(col);
	bgClr=new Color(Integer.parseInt(col,16));
	String cl=dbProps.getProperty("piechart.largestSector");
	if("onRight".equals(cl.trim()))bigPos=0;
	else if("onTop".equals(cl.trim()))bigPos=1;
	else if("onLeft".equals(cl.trim()))bigPos=2;
	else if("onBottom".equals(cl.trim()))bigPos=3;
	cl=dbProps.getProperty("piechart.fntsize");
	fSz=Integer.parseInt(cl);
}catch(Exception e){
e.printStackTrace();
}
    }

    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        if(g instanceof Graphics2D ) {
            Graphics2D g2 = (Graphics2D)g;
	    Font fnt=g2.getFont();
	    g2.setFont(fnt.deriveFont((float)fSz));
	    this.setBackground(bgClr);	
            Dimension d=new Dimension(this.getSize());
            int h=d.height;
            int w=d.width;
            //int cInc=(256/noOfBars);
            generateGraphData();
            //System.out.println(" "+cInc);    
            double sa,ea;
	    g2.rotate(-rAngle,w/2,(h-150)/2);
	    //if(empty)JOptionPane.showMessageDialog(new JFrame(), "","",JOptionPane.WARNING_MESSAGE);
            for(int i=0;i<noOfBars;i++) {    
                if(i==0)sa=0.0;
                else sa=angles[i-1];
                ea=angles[i];
                //if(sa>=180.0)sa=180.0-sa;
                //if(ea>=180.0)ea=180.0-ea;
                System.out.println("sa="+sa+" ea="+ea );
                g2.setPaint(clr[i%nClrs]);
                g2.fill(new Arc2D.Double(new Rectangle2D.Double(w/2-radious,(h-150)/2-radious,2*radious,2*radious),sa,ea-sa,Arc2D.PIE));
            }
	    g2.rotate(1*rAngle,w/2,(h-150)/2);
            g2.drawString(""+field,w/2-20,(h-150)/2+radious+50);
	    int length=2*(w-100)/noOfBars;
	    int st=0;
	    int end=-1;		
	    for(int j=0;j<noOfBars;j++){
		int r=1-j%2;
                int c=j/2;
		g2.setPaint(clr[j%nClrs]);
                g2.fill3DRect(100+length*c, h-r*50-40,30,30,false);
		end+=clusterSize[j];
		String legend=new String(st+"-"+end);
		if(st==end)legend=""+st;
		g2.drawString(legend,140+length*c,h-r*50-20);
		st+=clusterSize[j];
	 
	    }
	//Font fnt=g2.getFont();
	//Font fnt1=fnt;
	//g2.setFont(fnt.deriveFont(fSz));
	g2.setColor(Color.black);
	g2.drawString(title,(w-100)/2+50,25);
	//g2.setFont(fnt1);
        }
       else {
            // print error
        } 
    }   
    
    void generateGraphData() {
        clusterNo=new int[11];
        clusterSize=new int[noOfBars];
        //clusterSize=(int)(11.0/noOfBars+0.5);
        int finished=0;
        int clNo=0;
        for(int i=0;i<noOfBars;i++){
            clusterSize[i]=(int)((11-i)*1.0/noOfBars+0.999999);
            System.out.println("Cl= "+clusterSize[i]);
        }
        for(int i=0;i<noOfBars;i++){
            for(int j=0;j<clusterSize[i];j++)
            clusterNo[finished++]=i;
            System.out.println("f = "+finished);
        }
        System.out.println("noOfBars = " + noOfBars); 
        graphData = new int[noOfBars];
        total=0;
        for(int j=0;j<=10;j++){
            graphData[clusterNo[j]]
                += data[j];
            total+=data[j];
        }
	if(total==0){
	    total=10;
	    empty=true;
	}
	else
	    empty=false;
	
        angles=new double[noOfBars];
        angles[0]=(graphData[0]*1.0/total)*360;
	maxPie=(graphData[0]*1.0/total)*360;
	maxPos=0;
        for(int i=1;i<noOfBars;i++){
	    if((graphData[i]*1.0/total)*360>maxPie){
		maxPos=i;
		maxPie=(graphData[i]*1.0/total)*360;
	    }
            angles[i]=angles[i-1]+(graphData[i]*1.0/total)*360;
        }
	double pAngle;
	if(maxPos==0)pAngle=0;
	else pAngle=angles[maxPos-1];
	double middle=(angles[maxPos]+pAngle)/2;
	rAngle=bigPos*90-middle;
	rAngle*=(3.1415/180);
	System.out.println(middle+" "+maxPos+" "+rAngle);
    }
}

