import javax.swing.*;
import java.awt.geom.*;
import java.awt.*;
import java.io.*;
import java.util.*;

public class ScatChart extends JPanel{
   // static int[] data1 = {0,0,0,0,0,0,0,0,0,0,0};
    //static int[] data2 = {0,0,0,0,0,0,0,0,0,0,0};
    static int[] data1 = {};
    static int[] data2 = {};	
    static String field1="";
    static String field2="";
    static int dia=0;
    static Color bgClr=Color.white;
    static Color clr=Color.black,gClr;
    static boolean grid=true;
    String caption;	
    String propFileName="graphicalForm.cfg";
    ScatChart(){
	readFromFile();
    }

    ScatChart(int[] d1,int[] d2,String f1,String f2){
	data1=d1;
	data2=d2;
	field1=f1;
	field2=f2;
	readFromFile();
    }

    void readFromFile(){
try{	FileInputStream fis = new FileInputStream(propFileName);
        Properties dbProps = new Properties();
        dbProps.load(fis);
	String rad=dbProps.getProperty("scatterdiagram.diameter");
	dia=Integer.parseInt(rad);
	rad=dbProps.getProperty("scatterdiagram.color");
	if("black".equals(rad.trim()))clr=Color.black;
	    else if("white".equals(rad.trim()))clr=Color.white;
	    else if("blue".equals(rad.trim()))clr=Color.blue;
	    else if("green".equals(rad.trim()))clr=Color.green;
	    else if("yellow".equals(rad.trim()))clr=Color.yellow;
	    else if("magenta".equals(rad.trim()))clr=Color.magenta;
	    else if("pink".equals(rad.trim()))clr=Color.pink;
	    else if("cyan".equals(rad.trim()))clr=Color.cyan;
	    else if("lightgray".equals(rad.trim()))clr=Color.lightGray;
	    else if("darkgray".equals(rad.trim()))clr=Color.darkGray;
	    else if("red".equals(rad.trim()))clr=Color.red;
	    else if("orange".equals(rad.trim()))clr=Color.orange;
	    else clr=Color.white;
	rad=dbProps.getProperty("scatterdiagram.gridcolor");
	if("black".equals(rad.trim()))gClr=Color.black;
	    else if("white".equals(rad.trim()))gClr=Color.white;
	    else if("blue".equals(rad.trim()))gClr=Color.blue;
	    else if("green".equals(rad.trim()))gClr=Color.green;
	    else if("yellow".equals(rad.trim()))gClr=Color.yellow;
	    else if("magenta".equals(rad.trim()))gClr=Color.magenta;
	    else if("pink".equals(rad.trim()))gClr=Color.pink;
	    else if("cyan".equals(rad.trim()))gClr=Color.cyan;
	    else if("lightgray".equals(rad.trim()))gClr=Color.lightGray;
	    else if("darkgray".equals(rad.trim()))gClr=Color.darkGray;
	    else if("red".equals(rad.trim()))gClr=Color.red;
	    else if("orange".equals(rad.trim()))gClr=Color.orange;
	    else gClr=Color.white;
	rad=dbProps.getProperty("scatterdiagram.grid");
	caption=dbProps.getProperty("scatterdiagram.caption");
	System.out.println(rad);
	if("yes".equals(rad.trim()))grid=true;
	else grid=false;
	String col=dbProps.getProperty("scatterdiagram.bkgndColor");
	//System.out.println(col);
	bgClr=new Color(Integer.parseInt(col,16));
}catch(Exception e){
}
    }
    public static void main(String[] args) {
        JFrame j = new JFrame("Test01");
        j.setSize(500, 500);
        j.getContentPane().add(new ScatChart(),BorderLayout.CENTER);
        j.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        //j.pack();
        j.setVisible(true);
    }

    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        if(g instanceof Graphics2D ) {
            Graphics2D g2 = (Graphics2D)g;
	    this.setBackground(bgClr);	
            Dimension d=new Dimension(this.getSize());
            int h=d.height;
            int w=d.width;
	    //int xMax=findMax(data1);
	    //int yMax=findMax(data2);
	    int xMax=11;
	    int yMax=11;
	    g2.setColor(clr);
	    drawScales(g2,h,w);
	    for(int i=0;i<data1.length;i++){
		g2.drawArc(100+(int)(data1[i]*1.0*(w-100)/xMax)-dia/2,h-100-(int)(data2[i]*1.0*(h-100)/yMax)-dia/2,dia,dia,0,360);
	    }
	    Font fnt=g2.getFont();	
	    Font fnt1=fnt;
	    g2.setFont(fnt1.deriveFont((float)15.0));
	    g2.drawString(caption,60+(w-100)/2,h-25);
	    g2.setFont(fnt);
	}
    }

     
    void drawScales(Graphics2D g2,int h,int w){
	g2.drawLine(100,h-100,w,h-100);
	g2.drawLine(100,h-100,100,0);
	g2.drawString(field1,60+(w-100)/2,h-50);
	g2.drawString(field2,20,h-100-(h-100)/2);
	if(grid){
	    g2.setColor(gClr);
	    for(int i=1;i<=10;i++){
		
		g2.drawLine(100+(int)((i*1.0/11)*(w-100)),h-100,100+(int)((i*1.0/11)*(w-100)),0);
		g2.drawLine(100,h-100-(int)((i*1.0/11)*(h-100)),w,h-100-(int)((i*1.0/11)*(h-100)));
		
	    }
	    g2.setColor(clr);
	}
	for(int i=1;i<=10;i++){
	    g2.drawLine(100+(int)((i*1.0/11)*(w-100)),h-103,100+(int)((i*1.0/11)*(w-100)),h-97);
	    g2.drawString(""+i,100+(int)((i*1.0/11)*(w-100)),h-85);	
	    g2.drawLine(97,h-100-(int)((i*1.0/11)*(h-100)),103,h-100-(int)((i*1.0/11)*(h-100)));
	    g2.drawString(""+i,80,h-100-(int)((i*1.0/11)*(h-100)));	
	}
    }
}
