/*
 * SurveyMainForm.java
 *
 * Created on September 23, 2004, 9:35 AM
 */
import java.awt.event.KeyEvent;
import javax.swing.KeyStroke;
import java.awt.event.ActionEvent;
/**
 *
 * @author  gautham_anil
 */
public class SurveyMainForm extends javax.swing.JFrame implements java.awt.event.ActionListener /*implements java.lang.Runnable*/ {
    
    private String lI /* loginId */;
    SurveyMain sm;
    DBInterface db;
    QueryPanel qP;
    ResultPanel rP;
    boolean sR;
    boolean sG;
    
    /** Creates a new instance of SurveyMainForm */
    public SurveyMainForm(SurveyMain sm) {
        db = new DBInterface();
        this.sm = sm;
        initComponents();
    }
    
    private javax.swing.JMenuBar mB; /*  menuBar */
    private javax.swing.JPanel tP; /* topPanel */
    private javax.swing.JButton sGP; /* selectGraphicsPane */
    private javax.swing.JButton pQ; /* processQuery */
    private javax.swing.JPanel cLP; /* cardLayoutPanel */
    private GraphicPanel gP;
    
    
    private void initComponents() {
        javax.swing.JMenu m;
        javax.swing.JMenuItem mI;
        mB = new javax.swing.JMenuBar();
        gP = new GraphicPanel(this);
        
        m = new javax.swing.JMenu("Main");
        m.setMnemonic(java.awt.event.KeyEvent.VK_M);
        m.getAccessibleContext().setAccessibleDescription("The main menu");
        mB.add(m);
        
        mI = new javax.swing.JMenuItem("Logout");
        mI.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_L, ActionEvent.CTRL_MASK));
        mI.addActionListener(this);
        m.add(mI);
        
        mI = new javax.swing.JMenuItem("Close");
        mI.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F4, ActionEvent.ALT_MASK));
        mI.addActionListener(this);
        m.add(mI);
        
        setJMenuBar(mB);
        
        tP = new javax.swing.JPanel();
        tP.setLayout(new java.awt.FlowLayout());
        
        pQ = new javax.swing.JButton("Process Query");
        pQ.setActionCommand("processQuery");
        pQ.addActionListener(this);
        tP.add(pQ);
        
        sGP = new javax.swing.JButton("Show Graphics");
        sGP.setActionCommand("showGraphics");
        sGP.addActionListener(this);
        tP.add(sGP);

        qP = new QueryPanel();
        
        rP = new ResultPanel();
        
        cLP = new javax.swing.JPanel(new java.awt.CardLayout());
        //setDefaultCloseOperation(javax.swing.JFrame.DO_NOTHING_ON_CLOSE);
        setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
        getContentPane().setLayout(new java.awt.BorderLayout());
        //getContentPane().add(rP, java.awt.BorderLayout.CENTER);
        //rP.setVisible(false);
        getContentPane().add(cLP, java.awt.BorderLayout.CENTER);
        getContentPane().add(tP, java.awt.BorderLayout.NORTH);
        cLP.add(qP, "q");
        cLP.add(rP, "r");
        cLP.add(gP, "g");
        //setSize(500,400);
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-400)/2, (screenSize.height-300)/2, 400, 300);
        
        //set
    }
    
    //    public void run() {
    //        while(!login()) {}
    //        DBInterface db = new DBInterface();
    //        if(!db.hasBeenSurveyed(lI)) {
    //            SurveyPanel sP /* surveyPanel */ = new SurveyPanel(db.getSubjectArray());
    //            sP.doSurvey(null);
    //        }
    //    }
    //
    
    synchronized public void showGUI(String loginId) {
        //gP.
        lI = loginId;
        setTitle("Welcome, " + db.getUserName(lI));
        setVisible(true);
        try {
            this.wait();
        } catch(java.lang.InterruptedException e) {
            System.out.println("Interrupted. Exiting...");
            System.exit(0);
        }
    }
    
    
    //    public boolean login() {
    //
    //    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
    }
    
    synchronized public void actionPerformed(ActionEvent e) {
        String command = e.getActionCommand();
        if(command.equals("Logout")) {
            setVisible(false);
            this.notify();
        }
        if(command.equals("Close")) {
            this.notify();
            System.exit(0);
        }
        if(command.equals("processQuery")) {
            //java.sql.ResultSet rs = db.executeQuery(qP.getQuery());
            if(!sR) {
                System.out.println(qP.getQuery());
                rP.processQuery(qP.getQuery());
                ((java.awt.CardLayout)cLP.getLayout()).show(cLP, "r");
                pQ.setLabel("Show Query page");
                sR = true;
                sG = false;
            }
            else {
                ((java.awt.CardLayout)cLP.getLayout()).show(cLP, "q");
                pQ.setLabel("Process Query");
                sR = false;
                sG = false;
            }
        }
        if(command.equals("showGraphics")) {
            if(sG) {
                ((java.awt.CardLayout)cLP.getLayout()).show(cLP, (sR ? "r" : "g"));
                sG = false;
            }
            else {
                ((java.awt.CardLayout)cLP.getLayout()).show(cLP, "g");
                sG = true;
            }
        }
    }
}
