/*
 * SurveyPanel.java
 *
 * Created on September 22, 2004, 9:44 PM
 */
import javax.swing.JOptionPane;
import java.io.File;
import java.io.FileReader;
import java.io.BufferedReader;

/**
 *
 * @author  gautham_anil
 */
public class SurveyPanel extends javax.swing.JPanel implements java.awt.event.ActionListener {

    static String formTitle;
    static java.awt.Color bgColor;
    static java.awt.Color bnColor;
    static int wndW;
    static int wndH;
    static int btnW;
    static int btnH;
    //boolean centerWindow;
    static boolean systemDecorated = false;
    static boolean columnResizable = false;
    static boolean columnOptimal = false;
    
    
    {
        try {
            //javax.swing.UIManager.setLookAndFeel("com.birosoft.liquid.LiquidLookAndFeel");
            File f = new File("dataForm.cfg");
            System.out.println("config file is at " + f.getAbsolutePath());
            BufferedReader br = new BufferedReader(new FileReader(f));
            String line;
            while((line = br.readLine()) != null) {
                System.out.println("Line found = '"+ line +"'");
                String[] words = line.split(" ",2);
                System.out.println("w1 = " + words[0] + ", w2 = " + words[1]);
                if(words.length < 2) continue;
                for(int i = 0; i < words.length; i++) { System.out.print(words[i] + "-"); }
                System.out.println("");
                if(words[0].equals("title")) {
                    formTitle = words[1];
                    continue;
                }
                if(words[0].equals("bkgndColor")) {
                    bgColor = java.awt.Color.decode("0X" + words[1].toLowerCase());
                    continue;
                }
                if(words[0].equals("buttonColor")) {
                    bnColor = java.awt.Color.decode("0X" + words[1].toLowerCase());
                    continue;
                }
                if(words[0].equals("wndSize")) {
                    words = words[1].split(" ");
                    wndW = Integer.parseInt(words[0]);
                    wndH = Integer.parseInt(words[1]);
                    continue;
                }
                if(words[0].equals("btnSize")) {
                    words = words[1].split(" ");
                    btnW = Integer.parseInt(words[0]);
                    btnH = Integer.parseInt(words[1]);
                    continue;
                }
                if(words[0].equals("sysDecorated")) {
                    if(words[1].equals("true")) systemDecorated = true;
                    continue;
                }
                if(words[0].equals("colResizable")) {
                    if(words[1].equals("true")) columnResizable = true;
                    continue;
                }
                if(words[0].equals("colOptimal")) {
                    if(words[1].equals("true")) columnOptimal = true;
                    continue;
                }
            }
            System.out.println(formTitle+bgColor+bnColor+","+wndW+","+wndH+","+btnW+","+btnH+","+systemDecorated+columnResizable+columnOptimal);
/*        } catch (java.lang.ClassNotFoundException e) {
            System.out.println("Unable to set Aqua Look and Feel. Class not found.");
        } catch (java.lang.InstantiationException e) {
            e.printStackTrace();*/
        } catch (java.io.FileNotFoundException e) {
            e.printStackTrace();
        } catch (java.io.IOException e) {
            e.printStackTrace();
/*        } catch (java.lang.IllegalAccessException e) {
            e.printStackTrace();
        } catch (javax.swing.UnsupportedLookAndFeelException e) {
            e.printStackTrace();*/
        }
    }

    SubmitTableData sTD;
    
    javax.swing.JDialog sD; /*  surveyDialog */
    javax.swing.JTable sT; /* surveyTable */
    javax.swing.JScrollPane sTSP;
    javax.swing.JButton sB; /* submit */
    javax.swing.JPanel bP; /* buttonPanel */
    javax.swing.JComboBox rE; /* rangeEditor */ 
    
    /** Creates a new instance of SurveyPanel */
    public SurveyPanel(String[] s) {
        sTD = new SubmitTableData(s);
        
        initComponents();
    }
    
    private void initComponents() {
        sT = new javax.swing.JTable(sTD);
        sB = new javax.swing.JButton("Submit survey");
        bP = new javax.swing.JPanel();
        sTSP = new javax.swing.JScrollPane(sT);

        rE = new javax.swing.JComboBox();
        rE.addItem(new Integer(0));
        rE.addItem(new Integer(1));
        rE.addItem(new Integer(2));
        rE.addItem(new Integer(3));
        rE.addItem(new Integer(4));
        rE.addItem(new Integer(5));
        rE.addItem(new Integer(6));
        rE.addItem(new Integer(7));
        rE.addItem(new Integer(8));
        rE.addItem(new Integer(9));
        rE.addItem(new Integer(10));
        
        //qT.getColumnModel().getColumn(0).
        sT.getColumnModel().getColumn(1).setCellEditor(new javax.swing.DefaultCellEditor(rE));
        sT.getColumnModel().getColumn(1).setResizable(this.columnResizable);
        if(this.columnOptimal) sT.setAutoResizeMode(sT.AUTO_RESIZE_SUBSEQUENT_COLUMNS);

        sB.addActionListener(this);
        sB.setSize(this.btnW, this.btnH);
        
        bP.setLayout(new java.awt.FlowLayout());
        bP.add(sB);
        bP.setBackground(this.bgColor);

        setLayout(new java.awt.BorderLayout());
        add(sTSP, java.awt.BorderLayout.CENTER);
        add(bP, java.awt.BorderLayout.SOUTH);
    }
    
    public void actionPerformed(java.awt.event.ActionEvent e) {
        String action = e.getActionCommand();
        if(action.equals("Submit survey")) {
            //javax.swing.JDialog j = new javax.swing.JDialog(this.getParent(), "Dialog", true);
            //j.setSize(200,200);
            //j.setVisible(true);
            System.out.println("Dialog closed");
            sD.setVisible(false);
        }
    }
    
    public static void main(String[] args) {
        javax.swing.JFrame j = new javax.swing.JFrame("SurveyPanel Test");
        j.setSize(300, 300);
        j.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
        //j.getContentPane().add(new SurveyPanel(new String[] { "Cricket", "Football" }), java.awt.BorderLayout.CENTER);
        j.getContentPane().add(new javax.swing.JButton("dfgh"));
        j.setVisible(true);
        //new SurveyPanel(new String[] { "Cricket", "Football" }).doSurvey(j);
    }
    
    public int[] doSurvey(javax.swing.JDialog f) {
        sD = new javax.swing.JDialog(f, this.formTitle, true);
        sD.setContentPane(this);
        sD.setSize(this.wndW,this.wndH);
        sD.setDefaultLookAndFeelDecorated(!this.systemDecorated);
        sD.setVisible(true);
        return sTD.getMarks();
    }
}

class SubmitTableData extends javax.swing.table.AbstractTableModel {
    
    String[] subjects;
    int[] marks;
    
    SubmitTableData(String[] s) {
        subjects = s;
        marks = new int[subjects.length];
        for(int i=0; i< marks.length; i++) marks[i] = 0;
    }
    
    public int getColumnCount() {
        return 2;
    }    
    
    public int getRowCount() {
        return subjects.length;
    }
    
    public Object getValueAt(int rowIndex, int columnIndex) {
        if(columnIndex == 1)
            return new Integer(marks[rowIndex]);
        return subjects[rowIndex];
    }
    
    public void setValueAt(Object value, int rowIndex, int columnIndex) {
        marks[rowIndex] = ((Integer)value).intValue();
    }
    
    public String getColumnName(int columnIndex) {
        /*boolean test = (columnIndex <= 2);
        assert test;*/
        if(columnIndex == 0) return "Subject";
        if(columnIndex == 1) return "Mark";
        return "";
    }
    
    public boolean isCellEditable(int row, int columnIndex) {
        /*boolean test = (columnIndex <= 2);
        assert test;*/
        if(columnIndex == 1) return true;
        return false;
    }

    public int[] getMarks() {
        return marks;
    }
}