import java.io.*;
import javax.swing.*;
import java.awt.*;
import java.util.*;

public class Test02 {
    
    /** Creates a new instance of Test01 */
    public Test02() {
    }
    
    public static void main(String[] args) {
        JFrame j = new JFrame("Test01");
        j.setSize(500, 500);
        j.getContentPane().add(new BarGraph(),BorderLayout.CENTER);
        j.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        //j.pack();
        j.setVisible(true);
    }
    
}


class MyCanvas extends JPanel {
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        if(g instanceof Graphics2D ) {
            Graphics2D g2 = (Graphics2D)g;
            g2.drawLine(0, 0, 50, 50);
        }
        else {
            // print error
        }
    }
}


class BarGraph extends JPanel {
    static int[][]  data={{ 6,7,4,3,5,3,10,10,10,10,3},{1, 8,6,3,7,3,6,7,7,4,8},{2,5,5,6,3,6,4,7,4,7,3}};
    //int hMax;
    static int noOfBars=5;
    static int noOfFields=3;
    int[][] graphData;
    static String[] fields={"hockey","cricket","chess"};
    int clusterNo[];
    int clusterSize[];
    static int barWidth=10;
    static Color[] clr;
    static int nClrs=4;
    static Color bgClr;
    String title,xCaption,yCaption;
    String propFileName="graphicalForm.cfg";
    BarGraph(){
	clr= new Color[10];
	clr[0]=Color.red;
	clr[1]=Color.green;
	clr[2]=Color.blue;
	clr[3]=Color.yellow;
	bgClr=Color.magenta;
	readFromFile(); 
        //data={{ 6,7,4,3,5,3,6,6,6,2,3},{9, 8,6,3,7,3,6,7,7,4,8}};
    }
    
     //public void loadData(int[][] d,int nB,int nF,String[] f,Color[] c, int nC,Color b) {
    BarGraph(int[][] d,int nB,int nF,String[] f) {
        data = d;
        noOfBars = nB;
        noOfFields = nF;
        fields = f;
	clr= new Color[10];
	clr[0]=Color.red;
	clr[1]=Color.green;
	clr[2]=Color.blue;
	clr[3]=Color.yellow;
	bgClr=Color.magenta;
	readFromFile();
	//nClrs=nC;
	//clr=c;
	//bgClr=b;
    }
    void readFromFile(){
try{	FileInputStream fis = new FileInputStream(propFileName);
        Properties dbProps = new Properties();
        dbProps.load(fis);
	String width=dbProps.getProperty("bargraph.width");
	barWidth=Integer.parseInt(width);
	String clrst=dbProps.getProperty("bargraph.colorOrder");
	String[] clrAr=clrst.split("\\s");
	clr=new Color[clrAr.length];
	nClrs=clrAr.length;
	//System.out.prinln("************************************************iln");
	for(int i=0;i<clrAr.length;i++)
		if("black".equals(clrAr[i]))clr[i]=Color.black;
		else if("white".equals(clrAr[i]))clr[i]=Color.white;
		else if("blue".equals(clrAr[i]))clr[i]=Color.blue;
		else if("green".equals(clrAr[i]))clr[i]=Color.green;
		else if("yellow".equals(clrAr[i]))clr[i]=Color.yellow;
		else if("magenta".equals(clrAr[i]))clr[i]=Color.magenta;
		else if("pink".equals(clrAr[i]))clr[i]=Color.pink;
		else if("cyan".equals(clrAr[i]))clr[i]=Color.cyan;
		else if("lightgray".equals(clrAr[i]))clr[i]=Color.lightGray;
		else if("darkgray".equals(clrAr[i]))clr[i]=Color.darkGray;
		else if("red".equals(clrAr[i]))clr[i]=Color.red;
		else if("orange".equals(clrAr[i]))clr[i]=Color.orange;
		else clr[i]=Color.white;
	String cl=dbProps.getProperty("bargraph.bkgndColor");
	bgClr=new Color(Integer.parseInt(cl,16));
	title=dbProps.getProperty("bargraph.title");
	xCaption=dbProps.getProperty("bargraph.xcaption");
	yCaption=dbProps.getProperty("bargraph.ycaption");
}catch(Exception e){
}
    }	
    //public void loadData(int[][] d,int nB,int nF,String[] f,Color[] c, int nC,Color b) {
    public void loadData(int[][] d,int nB,int nF,String[] f) {
        data = d;
        noOfBars = nB;
        noOfFields = nF;
        fields = f;
	//nClrs=nC;
	//clr=c;
	//bgClr=b;
    }
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        if(g instanceof Graphics2D ) {
            Graphics2D g2 = (Graphics2D)g;
//	    g2.setBackground(bgClr);
	    this.setBackground(bgClr);
            Dimension d=new Dimension(this.getSize());
            int h=d.height;
            int w=d.width;
	    
            generateGraphData();
            int hMax=maxHeight();
            System.out.println(" "+hMax);
            hMax*=1.25;
	    if(hMax==0)hMax=10;
            
            //int barWidth=(w-100)/((noOfFields+1)*noOfBars+1);
            System.out.println(" "+hMax+" "+barWidth);
            //int cInc=(256/noOfFields);
            int st=0;
            int end=-1;
            String range;
            for(int i=0;i<noOfBars;i++){
                for(int j=0;j<noOfFields;j++){
                System.out.println("   "+j+" "+i+" "+((noOfFields+1)*i+1+j)*barWidth+" "+(int)((graphData[j][i]*1.0/hMax)*(h-150)));
                //g2.setPaint(new Color((float)(cInc*j),(float)((cInc)*(noOfFields-j)),(float)(cInc*(noOfFields-j))));
                //g2.setPaint(Color.BLUE);
                //g2.setPaint(new Color(j*cInc,0,255-j*cInc));
		g2.setPaint(clr[j%nClrs]);
                g2.fill3DRect(100+((noOfFields+1)*i+1+j)*barWidth, h-150-(int)((graphData[j][i]*1.0/hMax)*(h-150)),barWidth,(int)((graphData[j][i]*1.0/hMax)*(h-150)),false); 
                }
                end+=clusterSize[i];
                if(end>10)end=10;
                g2.setPaint(Color.BLACK);
                if(st!=end)
                    range=st+"-"+end;
                else
                    range=""+st;
                g2.drawString(range,100+(i*(noOfFields+1)+1+noOfFields/2)*barWidth,h-120);
               
                st+=clusterSize[i];
            }
            int length=(w-100)/(noOfFields/2+1);
            for(int j=0;j<noOfFields;j++){
                int r=1-j%2;
                int c=j/2;
                g2.setPaint(clr[j%nClrs]);
                g2.fill3DRect(100+length*c, h-r*50-40,30,30,false);
                g2.setPaint(Color.BLACK);
                g2.drawString(fields[j],140+length*c,h-r*50-20);
            }
	    int scaleIn=hMax/10;
            
            int scaleIncr=(int)((scaleIn*1.0/hMax)*(h-150));
            System.out.println(" "+scaleIncr);
            
            //drawscales();
            g2.drawLine(100,h-150,w ,h-150);
            g2.drawLine(100,h-150, 100,0);
            for(int i=1;(h-150-i*scaleIncr)>10;i++){
                g2.drawLine(97,h-150-i*scaleIncr,103,h-150-i*scaleIncr);
                g2.drawString(""+scaleIn*i,70,h-150-i*scaleIncr);
            }
            g2.drawString(xCaption,100+(w-100)/2-5,h-105);
            g2.drawString(yCaption,10,(h-150)/2);
	    g2.drawString(title,(w-100)/2+50,50);
        }
        else {
            // print error
        }
    }
    
    void drawscales(){
        
    }
    
    int maxHeight(){
        int hMax=0;
        for(int i=0;i<noOfFields;i++){
            for(int j=0;j<noOfBars;j++){
               if(graphData[i][j]>=hMax)hMax=graphData[i][j];  
            }
        }    
        return hMax;
    }
    
    void generateGraphData(){
        clusterNo=new int[11];
        clusterSize=new int[noOfBars];
        //clusterSize=(int)(11.0/noOfBars+0.5);
        int finished=0;
        int clNo=0;
        for(int i=0;i<noOfBars;i++){
            clusterSize[i]=(int)((11-i)*1.0/noOfBars+0.999999);
            System.out.println("Cl= "+clusterSize[i]);
        }
        for(int i=0;i<noOfBars;i++){
            for(int j=0;j<clusterSize[i];j++)
            clusterNo[finished++]=i;
            System.out.println("f = "+finished);
        }
        //System.out.println("clusterSize = " + clusterSize); 
        System.out.println("noOfBars = " + noOfBars); 
        graphData = new int[noOfFields][noOfBars];
        for(int i=0;i<noOfFields;i++){
            for(int j=0;j<=10;j++){
                graphData[i][clusterNo[j]]
                    += data[i][j];
            }
        }
    }
}
